#include "appointmentcontroller.h"
#include "time.h"
#include "stdio.h"
#include "qfile.h"
#include "qtextstream.h"
#include "patientcontroller.h"

AppointmentController::AppointmentController()
{
    QFile file("app.dat");
    if(file.open(QIODevice::ReadOnly)){
        QTextStream stream(&file);
        file.seek(0);
        while(!stream.atEnd()){
            AppointmentModel *a = new AppointmentModel;
            a->id = stream.readLine().toInt();
            a->name = stream.readLine();
            a->phone = stream.readLine();
            a->purpose = stream.readLine();
            a->date = stream.readLine();
            a->beginTime = stream.readLine().toInt();
            a->endTime = stream.readLine().toInt();
            a->comment = stream.readLine();
            a->state = stream.readLine();
            this->appointmentList.append(a);
        }
    }
    printf("Loaded data from app.dat.\n");
}

AppointmentController::~AppointmentController()
{
}

AppointmentModel* AppointmentController::make(QString name, QString phone, QString purpose, QString date, int beginTime, int endTime)
{
    AppointmentModel* a = new AppointmentModel;
    a->name = name;
    a->phone = phone;
    a->date = date;
    a->beginTime = beginTime;
    a->endTime = endTime;
    a->purpose = purpose;
    int id = time(0)%1000000;
    a->id = id;
    this->appointmentList.append(a);
    printf("Added new appointment %d.\n", a->id);
    return a;
}

void AppointmentController::cancel(int id)
{
    AppointmentModel* remove = 0;
    foreach(AppointmentModel* a, appointmentList){
        if(a->id == id){
            remove = a;
            break;
        }
    }
    if(remove){
        appointmentList.removeOne(remove);
        printf("Removed appointment %d.\n", remove->id);
    }
}

AppointmentModel* AppointmentController::find(QString date, int beginTime)
{
    foreach(AppointmentModel* a, appointmentList){
        if(a->date == date && a->beginTime == beginTime){
            printf("Found appointment %d.\n", a->id);
            return a;
        }
    }
    return 0;
}

QList<AppointmentModel*> AppointmentController::find(QString date)
{
    QList<AppointmentModel*> list;
    foreach(AppointmentModel* a, appointmentList){
        if(a->date == date){
            list.append(a);
        }
    }
    return list;
}

AppointmentModel* AppointmentController::find(int patientId)
{
    foreach(AppointmentModel* a, appointmentList){
        if(a->id == patientId){
            printf("Found appointment %d.\n", a->id);
            return a;
        }
    }
    return 0;
}

QList<AppointmentModel*> AppointmentController::find()
{
    return this->appointmentList;
}

void AppointmentController::save()
{
    QFile file("app.dat");
    if(file.open(QIODevice::WriteOnly)){
        QTextStream stream(&file);
        foreach(AppointmentModel* a, appointmentList){
            stream << a->id << '\n';
            stream << a->name << '\n';
            stream << a->phone << '\n';
            stream << a->purpose << '\n';
            stream << a->date << '\n' << a->beginTime << '\n' << a->endTime << '\n';
            stream << a->comment << '\n';
            stream << a->state << '\n';
        }
        file.close();
    }
}
