#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QDate>
#include "appointmentcontroller.h"
#include "qtablewidget.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void updateCalendar();
    void updateDaily();
    void updateWeekly();
    void updateNotification();

private slots:

    void on_calendarView_cellClicked(int row, int column);

    void on_calendarView_customContextMenuRequested(QPoint pos);

    void on_actionMake_triggered();

    void onTimerUpdate();
    void on_btnCurrentWeek_clicked();

    void on_btnPrevWeek_clicked();

    void on_btnNextWeek_clicked();

    void on_actionEdit_triggered();

    void on_actionCancel_triggered();

    void on_tabWidget_currentChanged(QWidget* );

    void on_tabWidget_currentChanged(int index);

    void on_MainWindow_destroyed();

    void on_dailyView_clicked(QModelIndex index);

    void on_btnSaveMark_clicked();

    void on_btnSearchName_clicked();

    void on_btnSearchDate_clicked();

private:
    Ui::MainWindow *ui;

    QDate dayOfWeek;
    AppointmentController appointmentController;

    QString makeTime(int begin, int end);

    void closeEvent(QCloseEvent *);
};

#endif // MAINWINDOW_H
